from trainer import train
from settings import Settings
import torch.optim as optim
from gtrxl import GTrXL
from environment import MerlinEnv
from q_network import Actor, ActorCritic, MLP

if __name__ == '__main__':
    params = Settings().parse_arguments()
    env_ids = params.env_ids.split(",")
    num_env = len(env_ids)

    s_network = MLP(128, 2)
    env = MerlinEnv(params.dataset, params.task, s_network)
    num_actions = env.action_space.n
    state_shape = env.observation_space.shape

    model = ActorCritic(state_shape, int(state_shape/2), num_actions)
    importance = GTrXL()
    

    train(env, model,  importance,  optim.Adam(model.parameters(), lr=1e-3), params.gamma)

