import argparse


class Settings:
    def __init__(self):
        self.initialized = False

    def parse_arguments(self):
        parser = argparse.ArgumentParser(description='Machine Learning running script')
        parser.add_argument('--env_ids', type=str,
                            default="MERLIN",
                            help='environments to test')
        parser.add_argument('--name', type=str, default="multitask_model_merlin",
                            help='name for the checkpoint model')
        parser.add_argument("--num_actors", type=int, default=3,
                            help="the number of actors to start")
        parser.add_argument("--num_steps", type=int, default=100,
                            help="max number of steps per episode")
        parser.add_argument('--batch_size', type=int, default=4, help='number of samples per batch')
        parser.add_argument('--gamma', type=float, default=0.99, help='discount factor')
        parser.add_argument('--lr', type=float, default=0.001, help='learning rate')
        parser.add_argument('--num_hidden_layers', type=int, default=1, help='# of hidden layersin core layer')
        parser.add_argument('--hidden_state_size', type=int, default=256, help='# of hidden nodes in core layer')
        parser.add_argument("--entropy_cost", type=float, default=0.00025,
                            help="Entropy cost/multiplier, default is 0.00025")
        parser.add_argument("--baseline_cost", type=float, default=.5,
                            help="Baseline cost/multiplier, default is 0.5")
        parser.add_argument("--use_popart", type=bool, default=True,
                            help="if use pop art normalization")
        parser.add_argument('--checkpoint_path', type=str, default="./checkpoint.pt",
                            help='Set the path to save trained model parameters')
        parser.add_argument('--dataset', type=str, default='enterprise_1.csv')
        parser.add_argument('--task', type=str, default='Engagement', help='Engagement/Adoption/All')
        parser.add_argument('--window', type=int, default=5)
        parser.add_argument('--cuda', type=bool, default=False, help='use gpu')
        settings = parser.parse_args()
        self.initialized = True
        return settings